local shadows = require("shadows")
local sti = require("sti")

local translation = {x = 0, y = 0}

local LightWorld = shadows.CreateWorld(5000, 5000)
local Light = shadows.CreateLight(LightWorld, 500)
Light:SetColor(255, 255, 255, 200)
Light:SetPosition(400, 400, 5)

--local Star = shadows.CreateStar(LightWorld, 50000)
--Star:SetColor(255, 255, 255, 255)
--Star:SetPosition(-2000, -2000, 300)

function love.load()
	
	windowWidth, windowHeight = love.graphics.getDimensions()
	
	love.physics.setMeter(32)
	
	map = sti("as_snow/as_snow.lua", {"box2d"})

	world = love.physics.newWorld(0, 0)
	
	map:box2d_init(world)
	LightWorld:SetPhysics(world)
	
end

function love.update(dt)
	
	if love.keyboard.isDown("w") then
		
		translation.y = translation.y - 10
		
	elseif love.keyboard.isDown("s") then
		
		translation.y = translation.y + 10
		
	end
	
	if love.keyboard.isDown("a") then
		
		translation.x = translation.x - 10
		
	elseif love.keyboard.isDown("d") then
		
		translation.x = translation.x + 10
		
	end
	
	map:update(dt)
	
	Light:SetPosition(translation.x + love.mouse.getX(), translation.y + love.mouse.getY(), 5)
	LightWorld:SetPosition(translation.x, translation.y)
	LightWorld:update()
	
end

love.graphics.maxFramerate = 60

function love.draw()
	
	love.graphics.setColor(255, 255, 255, 255)
	
	love.graphics.translate(-translation.x, -translation.y)
	map:draw()
	
	love.graphics.origin()
	LightWorld:draw(0, 0)
	
end

function love.mousepressed()
	
	Light = shadows.CreateLight(LightWorld, 300)
	Light:SetColor(math.random(0, 255), math.random(0, 255), math.random(0, 255), 255)
	
end